SystemOrganization addCategory: #MareaLogger!

!ProtoObject methodsFor: '*MareaLogger' stamp: 'MarianoMartinezPeck 10/22/2010 17:32'!
mareaLog: anObject
	MareaLogger logger log: anObject.! !

!AbstractObjectProxy methodsFor: '*MareaLogger' stamp: 'MarianoMartinezPeck 3/30/2011 15:11'!
mareaLog: anObject
	MareaLogger logger log: anObject.! !

Object subclass: #MareaLogger
	instanceVariableNames: ''
	classVariableNames: 'ProxiesLoggerHolder'
	poolDictionaries: ''
	category: 'MareaLogger'!

!MareaLogger classSide methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 10/20/2010 15:27'!
changeToFileLogger
	"ProxiesLogger changeToFileLogger"
	^ self initialize! !

!MareaLogger classSide methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 10/20/2010 15:25'!
changeToTranscriptLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: TranscriptLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!MareaLogger classSide methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/20/2010 15:14'!
createLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: (FixesFileNameLoggerStrategy named: 'Proxies.txt'). 
	logger startLogging.
	^ logger! !

!MareaLogger classSide methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 10/20/2010 15:28'!
disableLogging
	| logger |
	logger := SimpleLogger new.
	logger strategy: NullLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!MareaLogger classSide methodsFor: 'examples' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
example
	MyAppLogger logger mareaLog: 'zaraza'
	"Actually the idae is that you can create a method *MyAppLogger in Object that does:
	log: anObject
		MyAppLogger logger log: anObject
	
	So after, everywhere in your app you can just do self log: 'something'.
	"
	! !

!MareaLogger classSide methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/20/2010 17:08'!
initialize 
	ProxiesLoggerHolder := self createLogger.
	Smalltalk addToShutDownList: self.
	Smalltalk addToStartUpList: self.! !

!MareaLogger classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 15:15'!
logger
	ProxiesLoggerHolder
		ifNil: [ProxiesLoggerHolder := self createLogger].
	^ ProxiesLoggerHolder! !

!MareaLogger classSide methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/20/2010 17:07'!
shutDown
	self logger stopLogging.! !

!MareaLogger classSide methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 11/25/2010 17:17'!
startUp
 	self logger startLogging.
	! !

!MareaLogger methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 11/25/2010 17:16'!
seeClassSide ! !
MareaLogger initialize!
